using System.ComponentModel;
using System.Text.RegularExpressions;
using System.Windows.Forms;

namespace WindowsFormsToolkit.Controls.Validators
{
    /// <summary>
    /// Vrifie que la valeur saisie dans le contrle correspondant bien au pattern fournit
    /// </summary>
    [Description("Vrifie que la valeur saisie dans le contrle correspondant bien au pattern fournit")]
    public class RegularExpressionValidator : BaseValidator
    {
        private string pattern;
        private Control controlToValidate;
        [Description("Obtient ou dfini le contrle  valider")]
        public virtual Control ControlToValidate
        {
            get { return this.controlToValidate; }
            set { this.controlToValidate = value; }

        }

        [Description("Obtient ou dfini l'expression qui servira  valuer le contenu du contrle")]
        public string Pattern
        {
            get { return this.pattern; }
            set { this.pattern = value; }
        }

        protected override bool EvaluateIsValid()
        {
            return Regex.IsMatch(this.ControlToValidate.Text, this.pattern, RegexOptions.Compiled);
        }
    }
}
