using System.ComponentModel;
using System.Windows.Forms;

namespace WindowsFormsToolkit.Controls.Validators
{
    /// <summary>
    /// Vrifie qu'un champ obligatoire est bien saisie
    /// </summary>
    [Description("Vrifie qu'un champ obligatoire est bien saisie")]
    public class RequiredFieldValidator : BaseValidator
    {
        private Control controlToValidate;
        [Description("Obtient ou dfini le contrle  valider")]
        public virtual Control ControlToValidate
        {
            get { return this.controlToValidate; }
            set { this.controlToValidate = value; }

        }

        protected override bool EvaluateIsValid()
        {
            return !string.IsNullOrEmpty(this.ControlToValidate.Text.Trim());
        }
    }
}
